#include<stdio.h>
#include<stdlib.h>
#include "gfx.h"
#include<GL/gl.h>
#include<GL/glx.h>
#include<GL/glu.h>


double rotqube=5;

void DrawACube(void *dummy) {

  glClearColor(1.0, 1.0, 1.0, 1.0);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-2., 2., -2., 2., -30., 30.);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(0., 0., 10., 0., 0., 0., 0., 1., 0.);

  glTranslatef(0.0f, 0.0f,-7.0f);	// Translate Into The Screen 7.0 Units

  glRotatef(rotqube,0.0f,1.0f,0.0f);	// Rotate The cube around the Y axis
  glRotatef(rotqube,1.0f,1.0f,1.0f);
  glBegin(GL_QUADS);		// Draw The Cube Using quads
    glColor3f(0.0f,1.0f,0.0f);	// Color Blue
    glVertex3f( 1.0f, 1.0f,-1.0f);	// Top Right Of The Quad (Top)
    glVertex3f(-1.0f, 1.0f,-1.0f);	// Top Left Of The Quad (Top)
    glVertex3f(-1.0f, 1.0f, 1.0f);	// Bottom Left Of The Quad (Top)
    glVertex3f( 1.0f, 1.0f, 1.0f);	// Bottom Right Of The Quad (Top)
    glColor3f(1.0f,0.5f,0.0f);	// Color Orange
    glVertex3f( 1.0f,-1.0f, 1.0f);	// Top Right Of The Quad (Bottom)
    glVertex3f(-1.0f,-1.0f, 1.0f);	// Top Left Of The Quad (Bottom)
    glVertex3f(-1.0f,-1.0f,-1.0f);	// Bottom Left Of The Quad (Bottom)
    glVertex3f( 1.0f,-1.0f,-1.0f);	// Bottom Right Of The Quad (Bottom)
    glColor3f(1.0f,0.0f,0.0f);	// Color Red	
    glVertex3f( 1.0f, 1.0f, 1.0f);	// Top Right Of The Quad (Front)
    glVertex3f(-1.0f, 1.0f, 1.0f);	// Top Left Of The Quad (Front)
    glVertex3f(-1.0f,-1.0f, 1.0f);	// Bottom Left Of The Quad (Front)
    glVertex3f( 1.0f,-1.0f, 1.0f);	// Bottom Right Of The Quad (Front)
    glColor3f(1.0f,1.0f,0.0f);	// Color Yellow
    glVertex3f( 1.0f,-1.0f,-1.0f);	// Top Right Of The Quad (Back)
    glVertex3f(-1.0f,-1.0f,-1.0f);	// Top Left Of The Quad (Back)
    glVertex3f(-1.0f, 1.0f,-1.0f);	// Bottom Left Of The Quad (Back)
    glVertex3f( 1.0f, 1.0f,-1.0f);	// Bottom Right Of The Quad (Back)
    glColor3f(0.0f,0.0f,1.0f);	// Color Blue
    glVertex3f(-1.0f, 1.0f, 1.0f);	// Top Right Of The Quad (Left)
    glVertex3f(-1.0f, 1.0f,-1.0f);	// Top Left Of The Quad (Left)
    glVertex3f(-1.0f,-1.0f,-1.0f);	// Bottom Left Of The Quad (Left)
    glVertex3f(-1.0f,-1.0f, 1.0f);	// Bottom Right Of The Quad (Left)
    glColor3f(1.0f,0.0f,1.0f);	// Color Violet
    glVertex3f( 1.0f, 1.0f,-1.0f);	// Top Right Of The Quad (Right)
    glVertex3f( 1.0f, 1.0f, 1.0f);	// Top Left Of The Quad (Right)
    glVertex3f( 1.0f,-1.0f, 1.0f);	// Bottom Left Of The Quad (Right)
    glVertex3f( 1.0f,-1.0f,-1.0f);	// Bottom Right Of The Quad (Right)
  glEnd();			// End Drawing The Cube

} 

#define PAD       10
#define SCREEN_W  640
#define SCREEN_H  480

#define BUTTON_X  PAD
#define BUTTON_Y  PAD
#define BUTTON_W  80
#define BUTTON_H  25

enum {
  ACTION_1= GFXEV_LAST + 1,
};

#define TEST_X (BUTTON_X+BUTTON_W+PAD)
#define TEST_Y PAD
#define TEST_W (SCREEN_W-TEST_X-PAD)
#define TEST_H (SCREEN_H-TEST_Y-PAD)

 
int main(int argc, char *argv[])
{
  int btn;
  int btn_y;

  gfx_init(NULL,SCREEN_W,SCREEN_H,"Hello GL!\n");
  gfx_fill_rect(GFX_UPDATE, 0,0, SCREEN_W, SCREEN_H, 0xeeEE00);

  btn_y= BUTTON_Y;
  btn= gfx_button(GFX_UPDATE, BUTTON_X, btn_y, BUTTON_W, BUTTON_H, 
                  "Ehlo",ACTION_1);
  printf("button= %d\n", btn);

  btn_y += BUTTON_H;

  gfx_print(GFX_UPDATE,1, 0, 0xeeeeee, BUTTON_X, btn_y,"Testing",NULL,NULL);

  gfx_init_opengl(TEST_X,TEST_Y,TEST_W,TEST_H,DrawACube,NULL);
  gfx_update_all();
  
  while(1)
  {
    gfx_event_t event;
    if (!gfx_event(NULL,&event)) continue;
    switch(event.type)
    {
    case GFXEV_QUIT: goto done;
    case ACTION_1: 
         rotqube += 3.0f;
         gfx_opengl_frame();
         break;
    } 
  }
done:
  printf("Bye\n");
  return 0;
}

#if 0
                glXMakeCurrent(dpy, None, NULL);
                glXDestroyContext(dpy, glc);
                XDestroyWindow(dpy, win);
                XCloseDisplay(dpy);
                exit(0);
#endif
